# Contribution

Any contribution is more than welcome :heart:. Just fill an [issue](https://github.com/Nico-Curti/rFBP/blob/master/.github/ISSUE_TEMPLATE/ISSUE_TEMPLATE.md) or a [pull request](https://github.com/Nico-Curti/rFBP/blob/master/.github/PULL_REQUEST_TEMPLATE/PULL_REQUEST_TEMPLATE.md) and we will check ASAP!

## Before start contributing

- Make sure you agree to contribute your code under `rFBP` [license](https://github.com/Nico-Curti/rFBP/blob/master/LICENSE)

- If you are going to fix a bug, check that it's still exists and that you are working with the latest version of `rFBP` library.

- Make sure that there is not someone working on the same issue. In this case you can provide support or suggestion in the issue.

- If you have any question about the library fill an issue with the same criteria described in the previous step.

## Pull Request and Contribution

Please consider the following step to create a pull request which can be processed as quickly as possible

1. Install Git.

2. Create your account on Github.

3. Fork [this](https://github.com/Nico-Curti/rFBP) repository.

4. Create your feature branch (under `dev` branch).

5. Choose a task for yourself. It could be a bugfix or some new code.

6. Add documentation (`docstring`) to your functions/methods if you are working on the Python version. Add comments about what you are doing in functions/methods if you are working on the C++ version.

7. Add tests for your contributions

9. Pass **ALL** CI tests.

10. Submit a Pull Request into `dev` (following the pull request [template](https://github.com/Nico-Curti/rFBP/blob/master/.github/PULL_REQUEST_TEMPLATE/PULL_REQUEST_TEMPLATE.md))

## Merging

1. As soon as possible the authors will review your pull request, answering to your message.

2. Make sure you got credits at the end of merge: we have a lot of project to follow and we may forget to add your name to the list of `AUTHORS.md`. Please, do not hesitate to remind us!
